/*	Application		A program which allocates memory in 100,000 blocks each time the user presses a key.
	File			DynamicMemoryAllocation.cpp 
	Purpose			Demonstrates dynamic memory allocation
	Author			Richard John Anthony
	Date			January 2015
	
	Function		1. Runs in a loop requesting memory, finds allocation limit by doubling request size until a request is refused
					2. Requests and holds the maximum allocation memory amount discovered.
					3. Displays the amount of memory held
*/


#include "stdafx.h"
#include <malloc.h>
#include <iostream>

using namespace std;

#define AllocationIncrement 100000	// 100,000 bytes
#define InputBufferSize 100
char m_szInputBuf[InputBufferSize];

int _tmain(int argc, _TCHAR* argv[])
{
	char *pMemoryAllocated;
	long lTotalMemoryAllocated = 0;
	cout << "*******************************" << endl;
	cout << "*  Dynamic Memory Allocation  *" << endl;
	cout << "*******************************" << endl;
	
	while(1)
	{
		for(int iIndex = 0; iIndex < InputBufferSize; iIndex++)
		{   // Clear the input buffer
			m_szInputBuf[iIndex] = 0;
		}

		cout << endl << "Type a key to allocate a 100,000 byte block of memory";
		cout << endl << "or type \"Quit\" to quit: ";
		cin >> m_szInputBuf;
		if(	0 == strncmp(m_szInputBuf,"QUIT", 4) ||
			0 == strncmp(m_szInputBuf,"Quit", 4) ||
			0 == strncmp(m_szInputBuf,"quit", 4) )
		{
			cout << endl << "Quiting" << endl;
			return 0;
		}

		cout << "Requesting " << AllocationIncrement << " bytes";
		pMemoryAllocated = reinterpret_cast<char *>(malloc(AllocationIncrement));
		if(nullptr != pMemoryAllocated)
		{
			lTotalMemoryAllocated += AllocationIncrement;
			cout << " Result:ALLOCATED!  (Total now is: " << lTotalMemoryAllocated << " )" << endl;
		}
		else
		{
			cout << " Result:REFUSED!" << endl;
			cin >> m_szInputBuf;	// Wait for user to type a key (to allow them to read the message before the window is closed)
			return -1;
		}
	}
	return 0;
}

