/*	Application		IPC receiver-side using socket (UDP) - Message serialisation example		
	File			IPC_Receiver_MessageSerialisation.h
	Purpose			Demonstration of local IPC, with a serialised data structure, using a blocking socket
	Author			Richard John Anthony
	Date			January 2015
*/

#pragma once

#define RECEIVE_BUFFER_SIZE 100
#define RECEIVE_PORT 8007

// Message structure 
struct MyDetailsMessage {
	char	 cName[20];
	int 	 iAge; 
	char	 cAddress[50];
};

// Function declarations
bool InitialiseWindowsSocketsMechanism(void);
bool CreateSocket(void);
bool SetUpLocalAddressStruct(void);
IN_ADDR GetLocalHostAddressDetails(void);
bool BindToLocalAddress(void);
void ReadMessageFromReceiveBufferOrWait(void);
void CloseSocketAndExit(void);

// Global variables
int m_iPort;
SOCKET m_IPC_ReceiveSOCKET;		// Create a SOCKET variable to hold a reference to the created socket
char m_szRecvBuf[RECEIVE_BUFFER_SIZE];
SOCKADDR_IN m_LocalSockAddr;	// Create a SOCKADDR_IN variable to hold the local address (for receiving)
MyDetailsMessage m_ReceiveMessage;
