/*	Application		IPC sender-side using socket (UDP) - Message serialisation example	
	File			IPC_Sender_MessageSerialisation.cpp
	Purpose			Demonstration of local IPC, with a serialised data structure, using a blocking socket (on the receiving side)
	Author			Richard John Anthony
	Date			January 2015
*/

#pragma once

#define SEND_BUFFER_SIZE 100

// Message structure 
struct MyDetailsMessage {
	char	 cName[20];
	int 	 iAge; 
	char	 cAddress[50];
};

// Function declarations
bool InitialiseWindowsSocketsMechanism(void);
bool CreateSocket(void);
void SetUpSendAddressStructFor_LocalLoopback(void);
bool SendMessage();
void CloseSocketAndExit(void);

// Global variables
SOCKET m_SendSOCKET;	// Create a SOCKET variable to hold a reference to the created socket
char m_szSendBuf[SEND_BUFFER_SIZE];
int m_iSendLen;
SOCKADDR_IN m_SendSockAddr;	// Create a SOCKADDR_IN variable to hold the recipient's address
							// i.e. the address we are sending to
string m_UserInput;
MyDetailsMessage m_SendMessage;